/*
	(TCB)
	Distributed Measurement Demo Application	
	
--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 		

*/	

#include "tcb.h"
#include <signal.h>
#include "defs.h"

int tcbDesc,wiDesc;
char ip_addr[3000];

void exit_on_error(char * msg,int code)
{
	if (errno==0)
	 printTCBerror(code);
	  else
	   perror(msg);
	   
	closeTCBConnection(tcbDesc,wiDesc);   
	exit(1);   
}

void sigint_handler(int par)
{
	closeTCBConnection(tcbDesc,wiDesc);   
	printf("\nTCBPing stopped by user\n\n");
	exit(0);
}


int main(int argc,char* argv[])
{
	int res;
	TCBsocketDesc socketDesc;
	int ret;	
	TCBtimestamp sndtime,rcv_evt;
	TCBtimeinterval delay,error;	
 	struct sockaddr_in cnt,serv;
 	int len; 	
 	char buffer[1000];
	unsigned long long cnts;
	pingResp* pt;

	printf("\n----------------------------------------------------------\n");
	printf("TCBping (Client) - a linux like ping process using the TCB\n");
	printf("----------------------------------------------------------\n\n");
	
	        	
	if ((ret=openTCBConnection(&tcbDesc,&wiDesc))<OK)
	{
		printTCBerror(ret);
		exit(1);
	}
	
	signal(SIGINT,sigint_handler);
	
	if ((ret=TCBsocket(AF_INET,&socketDesc,tcbDesc))<0)
	{
		exit_on_error("Error on creating a TCB socket...\n\n",ret);
	}
	
 	bzero((char*)&cnt,0,sizeof(cnt));
	
 	cnt.sin_family=AF_INET;
 	cnt.sin_addr.s_addr=htonl(INADDR_ANY);
 	cnt.sin_port=htons(0);
 	
 	if ((ret=TCBbind((struct sockaddr*)&cnt,sizeof(cnt),&socketDesc))<0)
 	 {	
 	 	exit_on_error("Error on binding a TCB socket...\n",ret);
 	 }
 	
 	bzero((char*)&serv,0,sizeof(serv));
 	
 	serv.sin_family=AF_INET;
 	serv.sin_addr.s_addr=inet_addr("255.255.255.255");
 	serv.sin_port=htons(16006);
 
 	cnts=0;
 	while (1)
 	{
 	cnts++;
 	if ((cnts>200000))
 	{
 	 sndtime=getTCBTimestamp(tcbDesc);
 	 
  	 if ((ret=TCBsendto((char*)buffer,20,0,(struct sockaddr*)&serv,sizeof(serv),&socketDesc,sndtime))<0)
  	  {
  	  	exit_on_error("On sending a packet in a TCB socket...\n",ret);
  	  }
  	 cnts=0;
  	}
  	 
 	len=sizeof(cnt);
 	if ((ret=TCBrecvfrom((char*)buffer,sizeof(pingResp),0,(struct sockaddr*)&cnt,&len,&socketDesc,&rcv_evt,&delay,&error,NON_BLOCKING))>0) 	
 	{
 	 //message contents are after the MSGheader 	
 	 pt=(pingResp*)(buffer+sizeof(MSGheader));	
 	 printf("Packet From %s:\n",inet_ntoa(cnt.sin_addr.s_addr));
 	 printf("------------------------------------\n");
 	 printf("Send   : time <%llu> us error <%llu> us\n",pt->delay/1000,pt->error/1000);
 	 printf("Receive: time <%llu> us error <%llu> us\n",delay/1000,error/1000);
 	 printf("\n");
 	}	  
 	 else
 	 if (ret<0)   // ret==0 means no info on a NON_BLOCKING read
 	  {
 	     exit_on_error("On getting a message from a TCB socket...\n",ret);
 	  }
 	}
}

