/*
	(TCB)
	Distributed Measurement Demo Application	

--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 		

*/	


#include "tcb.h"
#include <signal.h>
#include "defs.h"

int tcbDesc,wiDesc;

void exit_on_error(char * msg,int code)
{
	if (errno==0)
	 printTCBerror(code);
	  else
	   perror(msg);
	   
	closeTCBConnection(tcbDesc,wiDesc);   
	exit(1);   
}

void sigint_handler(int par)
{
	closeTCBConnection(tcbDesc,wiDesc);   
	printf("\nTCBPing Server stopped by user\n\n");
	exit(0);
}

int main()
{
 	int res;
	TCBsocketDesc socketDesc;
	int ret;
	char ip_addr[300];
	TCBtimestamp sndtime,rcv_evt;
	TCBtimeinterval delay,error,delay_rnd,error_rnd;
 	struct sockaddr_in serv,cnt;
 	int len; 	
 	char buffer[1000];
	pingResp* pt;

	printf("\n----------------------------------------------------------\n");
	printf("TCBping (Server) - a linux like ping process using the TCB\n");
	printf("----------------------------------------------------------\n");
	
	if ( (ret=openTCBConnection(&tcbDesc,&wiDesc))<OK)
	{
		printTCBerror(ret);
		exit(1);
	}
	
	signal(SIGINT,sigint_handler);
	
	if ((ret=TCBsocket(AF_INET,&socketDesc,tcbDesc))<0)
	{
   	        exit_on_error("Error on creating a TCB socket...\n\n",ret);
	}
	
 	bzero((char*)&serv,0,sizeof(cnt));
 	
 	serv.sin_family=AF_INET;
 	serv.sin_addr.s_addr=htonl(INADDR_ANY);
 	serv.sin_port=htons(16006); 	
 	
 	if ((ret=TCBbind((struct sockaddr*)&serv,sizeof(serv),&socketDesc))<0)
 	 {	
 	 	exit_on_error("Error on binding a TCB socket...\n",ret);
 	 } 	  	  	
 	
	while (1)
	{ 	
	 	
 	len=sizeof(serv); 	
 	
 	if ((ret=TCBrecvfrom((char*)buffer,0,0,(struct sockaddr*)&cnt,&len,&socketDesc,&rcv_evt,&delay,&error,BLOCKING))>0) 	
 	{
 	  sndtime=getTCBTimestamp(tcbDesc);	
 	  
 	  //message contents are after the MSGheader 	
 	  pt=(pingResp*)(buffer+sizeof(MSGheader));	
 	  pt->error=error;
 	  pt->delay=delay;	
  	  if ((ret=TCBsendto((char*)buffer,sizeof(pingResp),0,(struct sockaddr*)&cnt,len,&socketDesc,sndtime))<0)
  	   {
  	   	exit_on_error("On send a packet in a TCB socket...\n",ret);
  	   }
 	}
 	else
 	{
 	  exit_on_error("On getting a message from a TCB socket...\n",ret);
 	}  
 	 	
	} 	
}

