/*
	(TCB)
	Local Timely Failure Detection Demo Application	
	 			 A FailSafe Application

--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 		
	 			 
*/

#include "tcb.h"
#include "control.h"
#include <rtl_sync.h>
#include <sys/time.h>
#include <sys/signal.h>

int fd0;

int tcbDesc,wiDesc;


void init_simul()
{
	int msg;

	if ((fd0 = open("/dev/rtf23", O_WRONLY)) < 0) {
		fprintf(stderr, "Error opening /dev/rtf23\n");
		exit(1);
	}

	msg= START_TASK;
	if (write(fd0, &msg, sizeof(msg)) < 0) {
		fprintf(stderr, "Can't send a command to RT-task\n");
		exit(1);
	}
	
	
}

void sig_int(int s)
{
	int msg;
	unsigned long long a;
	unsigned char b;

	msg= STOP_TASK;
	if (write(fd0, &msg, sizeof(msg)) < 0) {
		fprintf(stderr, "Can't send a command to RT-task\n");
	}

	closeTCBConnection(tcbDesc,wiDesc);	
	
	close(fd0);
	
	exit(0);
}

volatile int s=0;

void control_com(int f)
{
	s=1;
}

void control()
{
	int msg=REFRESH;
	struct itimerval value;

	value.it_value.tv_sec=1;
	value.it_value.tv_usec=40000;   // you must adjust this parameter
					// to your system ... try to find your
				        // execution time limit		
	value.it_interval.tv_sec=0;
	value.it_interval.tv_usec=0;
	
	write(fd0, &msg, sizeof(msg));			
	
	s=0;
	setitimer(ITIMER_REAL,&value,0);  // artificial delay	
	while (s==0){};
}

int main()
{
	int res,desc_lfd=0,ret,desc_lfd2=-100;
	TCBtimestamp start_evt,end_evt,start_evt2,end_evt2;
	TCBtimeinterval spec,deadline,proc_delay;
	Func_Id funcId;
	char faulty;
	int first=1;
	unsigned long c;
	
	signal(SIGALRM,control_com);
	signal(SIGINT,sig_int);
	
	// open a conection to TCB
	if ( (ret=openTCBConnection(&tcbDesc,&wiDesc))<OK)
	{
		printTCBerror(ret);
		exit(1);
	}
	
			
	printf("During the execution press <ctrl+c> to exit\n");
	printf("Press <enter> to continue\n");
	getchar();
	
	spec=1050000000;	
	deadline=200000;       // 200 microseconds
				
	strcpy(funcId.module,"app_module");
	strcpy(funcId.funcname,"timelyExec");
	strcpy(funcId.wcetname,"timelyExec_wcet");
	
	while (1)
	{
		
	start_evt=getTCBTimestamp(tcbDesc);
	
	desc_lfd=startTCBLocalFD(tcbDesc,start_evt,spec,deadline,funcId);		
	
	if ((first)&&(desc_lfd>=0))
	//now it is safe to start the simulation
	{
		first=0;
		init_simul();
	}
	
	if (first)	  //not a safe start
	  break;
	
	if (desc_lfd2!=-100)
	{
	
	  if (desc_lfd2!=ALREADY_FAILED)		
	  	{
		  ret=endTCBLocalFD(tcbDesc,desc_lfd2,&end_evt2,&proc_delay,&faulty);
		  if (faulty)
	  	  {
	  	  	printf("The application is in a failsafe state...\n");
		  	closeTCBConnection(tcbDesc,wiDesc);
		  	exit(0);
	  	  }
		}
		 else
		  {
		  	printf("Cannot continue...\n");
		  	closeTCBConnection(tcbDesc,wiDesc);
		  	exit(1);
		  }
	}
	
	control();
	
	start_evt2=getTCBTimestamp(tcbDesc);	  	
	desc_lfd2=startTCBLocalFD(tcbDesc,start_evt2,spec,deadline,funcId);  	
	if (desc_lfd!=ALREADY_FAILED)
		{
	  	  ret=endTCBLocalFD(tcbDesc,desc_lfd,&end_evt,&proc_delay,&faulty);
	  	  if (faulty)
	  	  {
	  	  	printf("The application is in a failsafe state...\n");
		  	closeTCBConnection(tcbDesc,wiDesc);
		  	exit(0);
	  	  }
	  	}
	  	 else
	  	 {
		  	printf("Cannot continue...\n");
		  	closeTCBConnection(tcbDesc,wiDesc);
		  	exit(1);
		  }
	control();
	}
	
	closeTCBConnection(tcbDesc,wiDesc);
	
	return 0;
}