/*
--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 		
*/


#include <linux/errno.h>
#include <rtl.h>
#include <time.h>

#include <rtl_sched.h>
#include <rtl_fifo.h>
#include "control.h"
#include <rtl_sync.h>
#include <asm/atomic.h>

pthread_t tasks[1];

volatile atomic_t ref={0};
int count=-1;
int working=1;


void *thread_code(void *t)
{
	int ret;
	rtl_irqstate_t state;

	pthread_make_periodic_np(tasks[0], 0xFFFFFFFFFFFFFFFF, 0);

	while (1) {
		ret = pthread_wait_np();
		
		if (!working)
		 break;
		
		rtl_no_interrupts(state);
		if (ref.counter==1)
		{			
			count=1;
			ref.counter=0;
			rtl_restore_interrupts(state);
			rtl_printf("\n");
		}
		 else
		 if (ref.counter==2)		 
		 {
		 	rtl_printf("FailSafe ShutDown....\n");
		 	working=0;
		 }
		 else
		  {
		  	rtl_restore_interrupts(state);
		  	if (count==10)
		  	{
		  	 rtl_printf("->FAIL\n");
		  	 count=0;
		  	} 
		  	 else
		  	 {
		  	  rtl_printf("X");
		  	  count++;
		  	 } 
		  }
		  
	}
	return 0;
}

int my_handler(unsigned int fifo)
{
	int msg;
	rtl_irqstate_t state;
	
	rtf_get(COMMAND_FIFO, &msg, sizeof(msg));
	switch (msg) {
				case START_TASK:
					count=1;
					pthread_make_periodic_np(tasks[0], gethrtime()+PERIOD, PERIOD);					
					break;
				case STOP_TASK:
					rtl_no_interrupts(state);
					pthread_suspend_np(tasks[0]);
					rtl_restore_interrupts(state);
					working=0;
					break;
				case REFRESH:
					rtl_no_interrupts(state);
					ref.counter=1;
					pthread_make_periodic_np(tasks[0], gethrtime()+PERIOD, PERIOD);
					rtl_restore_interrupts(state);
					return 0;
			}
	return 0;
}




/* #define DEBUG  */
int init_module(void)
{
	int c;
	pthread_attr_t attr;
	struct sched_param sched_param;
	int ret;

	rtf_destroy(COMMAND_FIFO);
	c = rtf_create(COMMAND_FIFO, 100);	/* input control channel */

	pthread_attr_init (&attr);
	sched_param.sched_priority = 0;
	pthread_attr_setschedparam (&attr, &sched_param);
	ret = pthread_create (&tasks[0],  &attr, thread_code, (void *)0);

	rtf_create_handler(COMMAND_FIFO, &my_handler); 
	ref.counter=0;
	return 0;
}


void cleanup_module(void)
{
	rtf_destroy(COMMAND_FIFO);
	pthread_suspend_np(tasks[0]);
	pthread_delete_np (tasks[0]);
}
