/*
	(TCB)
	Local Timely Failure Detection Demo Application	

--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 		
*/	
	
#include "tcb.h"
#include <sys/time.h>
#include <sys/signal.h>


int tcbDesc,wiDesc;



void sig_int(int s)
{
	closeTCBConnection(tcbDesc,wiDesc);	
	exit(0);
}

int main()
{
	int res,desc_lfd,ret;
	TCBtimestamp start_evt,end_evt;
	TCBtimeinterval spec,deadline,proc_delay;
	Func_Id funcId;
	char faulty;
	unsigned long long estimated=0;
	
	signal(SIGINT,sig_int);	
	
	// open a conection to TCB
	if ( (ret=openTCBConnection(&tcbDesc,&wiDesc))<OK)
	{
		printTCBerror(ret);
		exit(1);
	}
		
	
	printf("During the execution press <ctrl+c> to exit\n");
	printf("Press <enter> to continue\n");
	getchar();
	
	spec=estimated;	
	deadline=200000;       // 200 microseconds
				
	strcpy(funcId.module,"app_module");
	strcpy(funcId.funcname,"timelyExec");
	strcpy(funcId.wcetname,"timelyExec_wcet");
	
	while (1)
	{
	
	start_evt=getTCBTimestamp(tcbDesc);
	
	if (start_evt==TCB_ACESS_ERROR)
	{		
		printTCBerror((int)start_evt);
		printf("\n");
		closeTCBConnection(tcbDesc,wiDesc);
		exit(1);
	}
	
	desc_lfd=startTCBLocalFD(tcbDesc,start_evt,spec,deadline,funcId);
	
	if ((desc_lfd<0)&&(desc_lfd!=ALREADY_FAILED))
	{	
		printTCBerror((int)desc_lfd);
		printf("\n");
		closeTCBConnection(tcbDesc,wiDesc);
		exit(1);	
	}	
	
	if (desc_lfd==ALREADY_FAILED)
	{
		estimated+=10000;
		spec=estimated;
	}
	 else
	  {
	  	ret=endTCBLocalFD(tcbDesc,desc_lfd,&end_evt,&proc_delay,&faulty);
	  	if (ret<0)
		{	
			printTCBerror((int)ret);
			printf("\n");
			closeTCBConnection(tcbDesc,wiDesc);
			exit(1);	
		}
		
		if (faulty)
		{
			estimated=estimated+=10000;
			spec=estimated;
			
		}
		 else
		  {
			printf("DURATION: %llu us\n",proc_delay/1000);
		  }
	}
	}
	
	closeTCBConnection(tcbDesc,wiDesc);
	
	return 0;
}