/*
	(TCB)
	Local Measurement demo application
	
--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 		

*/	
	
#include "tcb.h"
#include <sys/time.h>
#include <sys/signal.h>


int tcbDesc,wiDesc;

void sig_int(int s)
{
	closeTCBConnection(tcbDesc,wiDesc);	
	exit(0);
}

int main()
{
	int res,desc_ms,ret;
	TCBtimestamp start_evt,end_evt;
	TCBtimeinterval proc_delay;
	
	signal(SIGINT,sig_int);	
	
	// open a conection to TCB
	if ( (ret=openTCBConnection(&tcbDesc,&wiDesc))<OK)
	{
		printTCBerror(ret);
		exit(1);
	}
		
	
	printf("During the execution press <ctrl+c> to exit\n");
	printf("Press <enter> to continue\n");
	getchar();
	
	while (1)
	{
	
	start_evt=getTCBTimestamp(tcbDesc);
	
	if (start_evt==TCB_ACESS_ERROR)
	{		
		printTCBerror((int)start_evt);
		printf("\n");
		closeTCBConnection(tcbDesc,wiDesc);
		exit(1);
	}
	
	desc_ms=startTCBMeasurement(tcbDesc,start_evt);
	
	if ((desc_ms<0))
	{	
		printTCBerror((int)desc_ms);
		printf("\n");
		closeTCBConnection(tcbDesc,wiDesc);
		exit(1);	
	}	
	
	// measured computation should be putted here
	
	ret=endTCBMeasurement(tcbDesc,desc_ms,&proc_delay,&end_evt);
	if (ret<0)
	{	
		printTCBerror((int)ret);
		printf("\n");
		closeTCBConnection(tcbDesc,wiDesc);
		exit(1);	
	}	
	printf("-----------\n");	
	printf("Measurement:\n");
	printf("-----------\n");	
	printf("Start Event : %lld\n",start_evt);	
	printf("End Event   : %lld\n",end_evt);		
	printf("Measurement : %lld\n",proc_delay);		
	
	sleep(1);
	}
	
	closeTCBConnection(tcbDesc,wiDesc);
	
	return 0;
}