/*	
--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 		
*/

#include "../system_defs.h"
#include "../include/driver_defs.h"
#include "../tcb/messages_formats.h"

int main()
{
	int max_mtu;
	int net_mtu=MTU,max_fields,max_items;
	
	max_mtu=NET_FIFO_SIZE/NUMBER_OF_MACHINES;
	
	if (max_mtu>net_mtu)
	 max_mtu=net_mtu;
	
	max_mtu=max_mtu/(NETWORK_OMISSION_DEGREE+1);	
	
	max_fields=(max_mtu-sizeof(msgtr_hdr))/sizeof(info_field);
		
	max_items=max_fields/(NUMBER_OF_MACHINES+1);

	printf("\n------------------\n");
	printf("TCB specifications\n");
	printf("------------------\n");
	printf(".Control channel device : <%s>\n",NET_DEVICE_NAME);
	printf(".Control channel MTU : <%u> bytes.\n",max_mtu);
	printf(".Control channel network card fifo size : <%u> bytes.\n",NET_FIFO_SIZE);
	printf(".Omission degree of the control channel : <%u>\n",NETWORK_OMISSION_DEGREE);
	printf(".Maximum packet size : <%u>\n",max_mtu);
	printf(".Minimum delivery delay on the control channel : <%u> us.\n",MINIMUM_DELIVERY_DELAY);
	printf(".Maximum round-trip value allowed for the control channel : <%u> us.\n",MAXIMUM_ROUNDTRIP);
	
#ifdef CONFIG_SELF_CHECKING_CONTROL_CHANNEL_SIMULATED	
	printf(".Self-Ckecking mode for the control channel : <simulated>\n");
#elif CONFIG_SELF_CHECKING_CONTROL_CHANNEL_REAL
	printf(".Self-Ckecking mode for the control channel : <real>\n");
#else
	printf(".Self-Ckecking mode for the control channel : <none>\n");	
#endif		
	printf(".Number of machines in the system: <%u>\n",NUMBER_OF_MACHINES);
	printf(".Maximum number of distributed failure detection protocol info fields allowed to be relayed in one send round : <%u>\n",max_fields);
	printf(".Maximum number of simultaneous distributed failure detection services allowed   by the TCB : <%u>\n",max_items);
	printf(".Maximum number of distributed failure detection services allowed by the TCB per send period : <%u>\n",max_items);
	printf(".Maximum number of simultaneous local failure detections allowed by the TCB: <%u>\n",MAX_LOCAL_FD);
	printf(".Maximum number of simultaneous timely executions allowed by the TCB: <%u>\n",MAX_EXEC);	
	printf("--------------------------------------------------------------------------------\n");	
	return 0;
}