/*	
--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 		
*/

#include "RndTripApp.h"

void init_session(RndTripInfo* rndinfo,unsigned char TCBID)
{
	unsigned char a;

	bzero((char*)rndinfo,sizeof(*rndinfo));
	for (a=0;a<NUMBER_OF_MACHINES;a++)
	{
	  rndinfo->lastRcv[a].error=0xFFFFFFFFFFFFFF;	
	  rndinfo->lastRcv[a].instant=0;
	  rndinfo->lastRcv[a].measure=0;
	  rndinfo->lastRcv[a].sndInst=0;
#ifdef RND_TEST
	  rndinfo->lastRcvNORMAL[a].error=0xFFFFFFFFFFFFFF;	
	  rndinfo->lastRcvNORMAL[a].instant=0;
	  rndinfo->lastRcvNORMAL[a].measure=0;
	  rndinfo->lastRcvNORMAL[a].sndInst=0;
#endif	  
	}
	rndinfo->tcbID=TCBID;
}

void putReceiveInfo(RndTripInfo* rndinfo,unsigned long long instant,unsigned long long other_interval,unsigned long long sndInst,unsigned long long respSndInst,unsigned char fromTcb,unsigned long long msg_measure,unsigned long long error_measure,unsigned long long DMdelay,unsigned long long* delay,unsigned long long *error)
{																																																													
	unsigned long long rndTripDelay;
	unsigned long long DelayUsingMsg,olddelay;
	unsigned long long error_with_rndTripDelay;
	unsigned long long error_with_delayUsingMsg;
	unsigned long long sel_measure;
	unsigned long long act_sel_error,sel_error;
	
	if (respSndInst==0) 	//first message
	{
		*delay=0; 
		error=0xFFFFFFFFFFFFFFFF;	
	
		if (rndinfo->lastRcv[fromTcb].instant==0)
		{
		 rndinfo->lastRcv[fromTcb].error=0xFFFFFFFFFFFFFF;
		 rndinfo->lastRcv[fromTcb].instant=instant;
		 rndinfo->lastRcv[fromTcb].sndInst=sndInst;
		 rndinfo->lastRcv[fromTcb].measure=0;
	        }
	         else {
	            if (
	             ((sndInst-rndinfo->lastRcv[fromTcb].sndInst)*(1+CLOCK_DRIFT_RATE))
	            >
	            ((instant-rndinfo->lastRcv[fromTcb].instant)*(1-CLOCK_DRIFT_RATE))
	            )
	            	{
	            	  rndinfo->lastRcv[fromTcb].error=0xFFFFFFFFFFFFFF;
	 	          rndinfo->lastRcv[fromTcb].instant=instant;
		          rndinfo->lastRcv[fromTcb].sndInst=sndInst;
		          rndinfo->lastRcv[fromTcb].measure=0;		          
	            	}
	          } 
	        //printf("NO SEND INST\n");
	        return ;
	}
	
	rndTripDelay=((((instant-respSndInst)*(1+CLOCK_DRIFT_RATE))-(other_interval*(1-CLOCK_DRIFT_RATE))-MINIMUM_DELIVERY_DELAY)/2);
	DelayUsingMsg=instant-respSndInst-other_interval-msg_measure;
	
	error_with_rndTripDelay=rndTripDelay;
	error_with_delayUsingMsg=error_measure+(CLOCK_DRIFT_RATE*(instant-respSndInst))+(other_interval*CLOCK_DRIFT_RATE);

	if (DelayUsingMsg<(error_with_delayUsingMsg+MINIMUM_DELIVERY_DELAY))
	{
		olddelay=DelayUsingMsg;
		DelayUsingMsg=(error_with_delayUsingMsg+DelayUsingMsg+MINIMUM_DELIVERY_DELAY)/2;		
		error_with_delayUsingMsg=(error_with_delayUsingMsg+olddelay-MINIMUM_DELIVERY_DELAY)/2;		
		
	}
	
	
	if (error_with_rndTripDelay<error_with_delayUsingMsg)
	{
		sel_error=error_with_rndTripDelay;
		sel_measure=rndTripDelay;
		if (msg_measure!=0)
		 {
		 	
		 	//printf("ERRO\n");
		 	//exit(1);
		 }
	}
	 else
	  {
	  	sel_error=error_with_delayUsingMsg;
	  	sel_measure=DelayUsingMsg;
	  }
	
	if (rndinfo->lastRcv[fromTcb].instant==0)
	{
	
		rndinfo->lastRcv[fromTcb].error=sel_error;
		rndinfo->lastRcv[fromTcb].instant=instant;
		rndinfo->lastRcv[fromTcb].sndInst=sndInst;
		rndinfo->lastRcv[fromTcb].measure=sel_measure;
		
	}
	else
	{
		if (sel_error <                                                                   
		rndinfo->lastRcv[fromTcb].error+((sndInst-rndinfo->lastRcv[fromTcb].sndInst)*(CLOCK_DRIFT_RATE))+((instant-rndinfo->lastRcv[fromTcb].instant)*(CLOCK_DRIFT_RATE)))
		{
		  rndinfo->lastRcv[fromTcb].error=sel_error;
		  rndinfo->lastRcv[fromTcb].instant=instant;
		  rndinfo->lastRcv[fromTcb].sndInst=sndInst;
		  rndinfo->lastRcv[fromTcb].measure=sel_measure;	
		}
	}
	
		
	*delay=sel_measure+DMdelay;
	*error=sel_error+(DMdelay*CLOCK_DRIFT_RATE);
	
}

#ifdef RND_TEST

void putReceiveNORMAL(RndTripInfo* rndinfo,unsigned long long instant,unsigned long long other_interval,unsigned long long sndInst,unsigned long long respSndInst,unsigned char fromTcb,unsigned long long msg_measure,unsigned long long error_measure,unsigned long long* delay,unsigned long long *error)
{																																					
	unsigned long long rndTripDelay;
	unsigned long long error_with_rndTripDelay;
	unsigned long long sel_measure;
	unsigned long long act_sel_error,sel_error;
	
	if (respSndInst==0) 	//first message
	{
		rndinfo->lastRcvNORMAL[fromTcb].instant=instant;
		rndinfo->lastRcvNORMAL[fromTcb].sndInst=sndInst;
		*delay=0;
	        *error=0xFFFFFFFFFFFFFFFF;
	        return ;
	}
	
	rndTripDelay=((((instant-respSndInst)*(1+CLOCK_DRIFT_RATE))-(other_interval*(1-CLOCK_DRIFT_RATE))-MINIMUM_DELIVERY_DELAY)/2);	
	error_with_rndTripDelay=rndTripDelay;

	if (rndinfo->lastRcvNORMAL[fromTcb].instant==0) {
		rndinfo->lastRcvNORMAL[fromTcb].instant=instant;
		rndinfo->lastRcvNORMAL[fromTcb].sndInst=sndInst;	
	}
	else	
	if (
	((sndInst-rndinfo->lastRcvNORMAL[fromTcb].sndInst)*(1+CLOCK_DRIFT_RATE))
	>
	((instant-rndinfo->lastRcvNORMAL[fromTcb].instant)*(1-CLOCK_DRIFT_RATE))
	)
	{
		rndinfo->lastRcvNORMAL[fromTcb].instant=instant;
		rndinfo->lastRcvNORMAL[fromTcb].sndInst=sndInst;
	}
	
	
	*delay=rndTripDelay;
	*error=error_with_rndTripDelay;																																																																												
}
																																																										
#endif

//ver valor de retorno!!!!!!!!!!!!!!!!!!
unsigned long long gettime(int descriptor)
{	
	ReqTcbHeader msg;
	TCBtimestamp ts;
	
	msg.srvc=get_timestamp;
	msg.sizeofmsg=0;

	if (write(descriptor, &msg, sizeof(msg)) < 0)
		return TCB_ACESS_ERROR;
	
	if (read(descriptor,&ts,sizeof(TCBtimestamp)) <0 )
		return TCB_ACESS_ERROR;
		
	return ts;  
	
}

int notify_tcb_of_receipt(int descriptor,unsigned char from,unsigned long seq,unsigned long long ts)
{	
	char snd[sizeof(msg_rcv_on_payloadPars)+sizeof(ReqTcbHeader)];
	ReqTcbHeader msg;
	msg_rcv_on_payloadPars pt;
	int res;
	
	msg.srvc=msg_received_on_payload;
	msg.sizeofmsg=sizeof(msg_rcv_on_payloadPars);
	
	pt.seq=seq;
	pt.time=ts;
	pt.from=from;
	
	//PARA MUDAR
	memcpy(snd,&msg,sizeof(msg));
	memcpy((snd+sizeof(msg)),&pt,sizeof(pt));
	
	if (write(descriptor, &snd, sizeof(snd)) < 0) 
		return TCB_ACESS_ERROR;
	
	if (read(descriptor,&res,sizeof(res)) <0 ) return TCB_ACESS_ERROR;
				
	return res;  	
}

																													
int my_rcv(RndTripInfo* rndinfo,int s,void* buf,unsigned int flags,struct sockaddr* from,int * fromlen,unsigned long long* delay,unsigned long long *error,char block,unsigned long long* rcv_time)
{																																																																															
	unsigned char msg_type=1;
	MSGheader* pt_header;
	RndTripField* pt_rnd;
	int ret;
	unsigned long long instant,se;
	struct sockaddr_in rec;
	fd_set fds;
	struct timeval tv;
	int ret_val;
	unsigned long long Rsnd;
	
	while (msg_type!=NORMAL_MSG)
	{
	 
	 //non blocking call
	 if (!block)
	 {
	 	FD_ZERO(&fds);
	 	FD_SET(s,&fds);	 		 	
	 	
	 	tv.tv_sec=0;
	 	tv.tv_usec=0;
	 	
	 	ret_val=select(s+1,&fds,NULL,NULL,&tv);
	 	
	 	if (!ret_val)
	 	{
	 	 return 0;
	 	}
	 	
	 }	 
	 ret=recvfrom(s,buf,0xFFFFFFF,0,from,fromlen); 	 		
//	printf("RECEBI ALGUMA %u\n",ret);
	 if (ret<=0)
	  return ret;
	 pt_header=(MSGheader*)buf; 
	 msg_type=pt_header->type;
	 switch (msg_type)
	 {
	  case NORMAL_MSG:	
	  			 pt_rnd=(RndTripField*)&pt_header->infoRndTrip[rndinfo->tcbID];
	  			 *rcv_time=gettime(rndinfo->TCBdescriptor);	  	  			 
	  			 if (pt_header->seq!=0)			 
	  			 {
	  			 if (notify_tcb_of_receipt(rndinfo->TCBdescriptor,pt_header->srcId,pt_header->seq,*rcv_time)!=0)
	  			 {
	  			 	msg_type=1;   //if the TCB has no space to store the information, then simulate an omission
	  			 }
	  			 else
	  			 {																			
	  			   putReceiveInfo(rndinfo,*rcv_time,pt_rnd->diff,pt_header->sndInst,pt_rnd->respSndInst,pt_header->srcId,pt_rnd->msg_measure,pt_rnd->error_measure,pt_header->DMdelay,delay,error);
				   return ret-sizeof(MSGheader);
				 }
				 }
				  else
				   {									
				     putReceiveInfo(rndinfo,*rcv_time,pt_rnd->diff,pt_header->sndInst,pt_rnd->respSndInst,pt_header->srcId,pt_rnd->msg_measure,pt_rnd->error_measure,pt_header->DMdelay,delay,error);
				     return ret-sizeof(MSGheader);
				   } 
	  			break;			
	case PROTOCOL_MSG:	
	  			{
	  		        }		  			
	  			break;	  						
	  			
	 }
	}	 	 
}

#ifdef RND_TEST

int my_rcv2(RndTripInfo* rndinfo,int s,void* buf,void** data_buff,unsigned int flags,struct sockaddr* from,int * fromlen,unsigned long long* delay,unsigned long long *error,unsigned long long*delay_using_rndt,unsigned long long* error_using_rndt,char block,unsigned long long* rcv_time)
{
	unsigned char msg_type=1;
	MSGheader* pt_header;
	RndTripField* pt_rnd,*pt_rndNORMAL;
	int ret;
	unsigned long long instant,se;
	struct sockaddr_in rec;
	fd_set fds;
	struct timeval tv;
	int ret_val;
	unsigned long long Rsnd;

	
	while (msg_type!=NORMAL_MSG)
	{
	 
	 //non blocking call
	 if (!block)
	 {
	 	FD_ZERO(&fds);
	 	FD_SET(s,&fds);	 		 	
	 	
	 	tv.tv_sec=0;
	 	tv.tv_usec=0;
	 	
	 	ret_val=select(s+1,&fds,NULL,NULL,&tv);
	 	
	 	if (!ret_val)
	 	{
	 	 return 0;
	 	}
	 	
	 }	 
	 ret=recvfrom(s,buf,0xFFFFFFF,0,from,fromlen); 	 		
	// printf("RECEBI ALGUMA\n");
	 if (ret<=0)
	  return ret;
	 pt_header=(MSGheader*)buf; 
	 msg_type=pt_header->type;
	 switch (msg_type)
	 {
	  case NORMAL_MSG:	
	  			 pt_rnd=(RndTripField*)&pt_header->infoRndTrip[rndinfo->tcbID];
	  			 pt_rndNORMAL=(RndTripField*)&pt_header->infoRndTripNORMAL[rndinfo->tcbID];
	  			 *rcv_time=gettime(rndinfo->TCBdescriptor);	  	  			 
	  			 if (pt_header->seq!=0)			 
	  			 {
	  			 if (notify_tcb_of_receipt(rndinfo->TCBdescriptor,pt_header->srcId,pt_header->seq,*rcv_time)!=0)
	  			 {
	  			 	msg_type=1;   //if the TCB has no space to store the information, then simulate an omission
	  			 }
	  			 else
	  			 {																																	
	  			   putReceiveInfo(rndinfo,*rcv_time,pt_rnd->diff,pt_header->sndInst,pt_rnd->respSndInst,pt_header->srcId,pt_rnd->msg_measure,pt_rnd->error_measure,delay,error);
	  			   putReceiveNORMAL(rndinfo,*rcv_time,pt_rndNORMAL->diff,pt_header->sndInst,pt_rndNORMAL->respSndInst,pt_header->srcId,pt_rndNORMAL->msg_measure,pt_rndNORMAL->error_measure,delay_using_rndt,error_using_rndt);
				   return ret-sizeof(MSGheader);
				 }
				 }
				  else
				   {									
				     putReceiveInfo(rndinfo,*rcv_time,pt_rnd->diff,pt_header->sndInst,pt_rnd->respSndInst,pt_header->srcId,pt_rnd->msg_measure,pt_rnd->error_measure,delay,error);
				     putReceiveNORMAL(rndinfo,*rcv_time,pt_rndNORMAL->diff,pt_header->sndInst,pt_rndNORMAL->respSndInst,pt_header->srcId,pt_rndNORMAL->msg_measure,pt_rndNORMAL->error_measure,delay_using_rndt,error_using_rndt);
				     return ret-sizeof(MSGheader);
				   } 
	  			break;			
	case PROTOCOL_MSG:	
	  			{
	  		        }		  			
	  			break;	  						
	  			
	 }
	}																																																																															
}
#endif


int my_send(RndTripInfo* rndinfo,int s,const void* msg,int len,unsigned int flags,const struct sockaddr* to,int tolen,unsigned char mtype,unsigned long long time_s,unsigned long seq)
{																														
	unsigned char a;	
	MSGheader* pt_header=(MSGheader*)msg;
	unsigned long long rnd_time;
	
	len+=sizeof(MSGheader);			
	pt_header->type=mtype;
	pt_header->srcId=rndinfo->tcbID;
	pt_header->seq=seq;
	rnd_time=gettime(rndinfo->TCBdescriptor);	  	  			 	
	pt_header->DMdelay=rnd_time-time_s;
	pt_header->sndInst=rnd_time;
	for (a=0;a<NUMBER_OF_MACHINES;a++)
	{		   
		   if (rndinfo->lastRcv[a].instant!=0)
		   {
		    pt_header->infoRndTrip[a].diff=rnd_time-rndinfo->lastRcv[a].instant;		  		    
		    pt_header->infoRndTrip[a].msg_measure=rndinfo->lastRcv[a].measure;
		    pt_header->infoRndTrip[a].respSndInst=rndinfo->lastRcv[a].sndInst;
		    pt_header->infoRndTrip[a].error_measure=rndinfo->lastRcv[a].error;		 
		   }
		    else
		     {
		       pt_header->infoRndTrip[a].diff=0;
		       pt_header->infoRndTrip[a].msg_measure=0;
		       pt_header->infoRndTrip[a].respSndInst=0;
		       pt_header->infoRndTrip[a].error_measure=0;
		     } 
#ifdef RND_TEST
		if (rndinfo->lastRcvNORMAL[a].instant!=0)
		   {
		    pt_header->infoRndTripNORMAL[a].diff=rnd_time-rndinfo->lastRcvNORMAL[a].instant;		  		    
		    pt_header->infoRndTripNORMAL[a].msg_measure=rndinfo->lastRcvNORMAL[a].measure;
		    pt_header->infoRndTripNORMAL[a].respSndInst=rndinfo->lastRcvNORMAL[a].sndInst;
		    pt_header->infoRndTripNORMAL[a].error_measure=rndinfo->lastRcvNORMAL[a].error;		 
		   }
		    else
		     {
		       pt_header->infoRndTripNORMAL[a].diff=0;
		       pt_header->infoRndTripNORMAL[a].msg_measure=0;
		       pt_header->infoRndTripNORMAL[a].respSndInst=0;
		       pt_header->infoRndTripNORMAL[a].error_measure=0;
		     }
#endif
	}
	
//	printf("CLN SEND: SEQ: %llu INST: %llu\n",pt_header->infoRndTrip[0].snd_seq,act_time);

 	return sendto(s,msg,len,0,to,tolen);	
}


