/*	
--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 		
*/

#ifndef tcb

//#define RND_TEST	1

#include <stdlib.h>
#include <stdio.h>
#include <netinet/in.h>
#include <linux/inet.h>
#include <sys/time.h>
#include "../system_defs.h"   // MINIMUM_DLIVERY_DELAY & CLOCK_DRIFT_RATE

/*          B                C
	------------------------------    para m2:	
 	    ^                  \   -----> --------
	   / m1               m2 \        diff=C-B
 	  /                        v      respSndInst=A  
	-------------------------------   sndInst=C
					  msg_measure(m1), error_measure(m1)
	 A                          D 
*/
typedef struct
	{
		unsigned long long diff,respSndInst;
		unsigned long long msg_measure,error_measure;
	}
RndTripField;	

typedef RndTripField RndTripFields[NUMBER_OF_MACHINES];

#define NORMAL_MSG 		0
#define PROTOCOL_MSG		1

typedef struct
	{
		unsigned char		srcId;
		unsigned char		type;		
		unsigned long long      sndInst;  // of the RndTrip protocol
		unsigned long long      DMdelay;   
#ifdef RND_TEST		
		RndTripFields		infoRndTripNORMAL;
#endif		
		RndTripFields		infoRndTrip;
		unsigned long		seq;  	        // 0 means no info
	}
MSGheader;	

typedef struct {
		unsigned long long instant;
		unsigned long long sndInst;
		unsigned long long error;
		unsigned long long measure;
	}       
ReceiveMsgInfo;

typedef struct {
#ifdef RND_TEST
		ReceiveMsgInfo     lastRcvNORMAL[NUMBER_OF_MACHINES];		
#endif		
		ReceiveMsgInfo     lastRcv[NUMBER_OF_MACHINES];		
		unsigned long	   seq;			
		unsigned char      tcbID;
		int		   TCBdescriptor;
}
RndTripInfo;


#define NON_BLOCKING 0
#define BLOCKING     1

#endif