
/*	
--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 		
*/


#include "tcb.h"
#define tcb
#include "RndTripApp.c"

// returns descriptor
//	   TCB_ACESS_ERROR	
//	   NO_AVAIL_CONN

int openTCBConnection(int *tcb_desc,int *wait_info_desc)
{
	int fd,con,desc;
	ReqTcbHeader msg;
	char aux[30];
	
	if ((fd=open("/dev/rtf1", O_RDWR))==-1)   
		return TCB_ACESS_ERROR;
	
	msg.srvc=get_connection;
	msg.sizeofmsg=0;
	
	if (write(fd, &msg, sizeof(msg)) < 0) 
		return TCB_ACESS_ERROR;
	
	if (read(fd,&con,sizeof(int)) <0 )
		return TCB_ACESS_ERROR;
		
	close(fd);	
		
	if (con<0) return con;	
	
	sprintf(aux,"/dev/rtf%d",con);
	if ((*tcb_desc = open(aux, O_RDWR)) < 0) 
		return TCB_ACESS_ERROR;
		
	sprintf(aux,"/dev/rtf%d",(con+3));   //PARA MUDAR POR DEF
	if ((*wait_info_desc = open(aux, O_RDWR)) < 0) 
		{
		close(desc);	
		return TCB_ACESS_ERROR;	
		}
	
	  
	return 0;
}


// returns OK
//	   TCB_ACESS_ERROR	

int closeTCBConnection(int descriptor,int wait_info_desc)
{
	ReqTcbHeader msg;	
	
	msg.srvc=end_connection;
	msg.sizeofmsg=0;
	
	if (write(descriptor, &msg,sizeof(msg)) < 0) 
		return TCB_ACESS_ERROR;
	
	close(descriptor);	
	close(wait_info_desc);    
	return 0;
}


// returns Timestamp	

TCBtimestamp getTCBTimestamp(int descriptor)
{
	ReqTcbHeader msg;
	TCBtimestamp ts;
	
	msg.srvc=get_timestamp;
	msg.sizeofmsg=0;

	if (write(descriptor, &msg, sizeof(msg)) < 0) 
		return TCB_ACESS_ERROR;
	
	if (read(descriptor,&ts,sizeof(TCBtimestamp)) <0 )
		return TCB_ACESS_ERROR;
		
	return ts;	
}

// return ID
// TCB_ACESS_ERROR	
int getTCBid(int descriptor) {
	ReqTcbHeader msg;
	int id;
	
	msg.srvc=get_id;
	msg.sizeofmsg=0;

	if (write(descriptor, &msg, sizeof(msg)) < 0) 
		return TCB_ACESS_ERROR;
	
	if (read(descriptor,&id,sizeof(id)) <0 )
		return TCB_ACESS_ERROR;
		
	return id;
}

//NOTA: a medicao local vai ser passada para user level....nao ha necessidade
//	de ser concretizada dentro da TCB, mas para ja fica assim

// returns localM descriptor
//	   TCB_ACESS_ERROR	
//         NO_AVAIL_LOCAL_MEASURE   

int startTCBMeasurement(int descriptor,TCBtimestamp ts)
{
	char snd[sizeof(TCBtimestamp)+sizeof(ReqTcbHeader)];
	TCBtimestamp *body=(TCBtimestamp*) ((ReqTcbHeader*)&snd+1);		
	ReqTcbHeader* msg;
	int desc;

	msg=(ReqTcbHeader*)&snd;

	msg->srvc=start_localM;
	msg->sizeofmsg=sizeof(TCBtimestamp);
		
	*body=ts;
	
	if (write(descriptor, &snd,sizeof(ReqTcbHeader)+msg->sizeofmsg) < 0) 
		return TCB_ACESS_ERROR;
	
	if (read(descriptor,&desc,sizeof(int)) <0 )
		return TCB_ACESS_ERROR;
	
	return desc;	
}


// returns OK
//	   TCB_ACESS_ERROR	
//	   INVALID_LOCALM_DESC	

int endTCBMeasurement(int descriptor,int measuredesc,TCBtimeinterval* tm,TCBtimestamp* end_ev)
{
	char snd[sizeof(int)+sizeof(ReqTcbHeader)];
	int *body=(int*) ((ReqTcbHeader*)&snd+1);			
	ReqTcbHeader* msg;
	endLocalMResult res;	
	
	msg=(ReqTcbHeader*)&snd;
	msg->srvc=end_localM;
	msg->sizeofmsg=sizeof(int);
		
	*body=measuredesc;
	
	if (write(descriptor, &snd,sizeof(ReqTcbHeader)+msg->sizeofmsg) < 0) 
		return TCB_ACESS_ERROR;
	
	if (read(descriptor,&res,sizeof(res)) <0 )
		return TCB_ACESS_ERROR;
		
	if (res.stat!=OK) return res.stat;	
		
	*tm=res.tm;
	*end_ev=res.ts;	

	return OK;		
}

// returns end_evt
//	   TCB_ACESS_ERROR	
//	   FUNC_NOT_FOUND	  
//	   WCET_FUNC_NOT_FOUND	  			
//	   NO_AVAIL_EXEC          
//	   CANT_RUN_TIMELY

TCBtimestamp startTCBExec(int descriptor,TCBtimestamp start_ev, TCBtimeinterval delay, TCBtimeinterval max_exec,Func_Id func,char* TraceName)
{
	execPars* pars;	
	ReqTcbHeader* msg;
	char snd[sizeof(execPars)+sizeof(ReqTcbHeader)];
	TCBtimestamp res;
	
	msg=(ReqTcbHeader*)&snd;
	pars=(execPars*)((ReqTcbHeader*)&snd+1);
	
	msg->srvc=exec;
	msg->sizeofmsg=sizeof(execPars);
	
	pars->start_ev=start_ev;
	pars->delay=delay;
	pars->max_exec=max_exec;
	
	strncpy(pars->funcName,func.funcname,50);
	strncpy(pars->modName,func.module,50);
	strncpy(pars->wcetName,func.wcetname,50);
	strncpy(pars->TraceName,TraceName,20);
       	
	if (write(descriptor, &snd,sizeof(ReqTcbHeader)+msg->sizeofmsg) < 0) 
		return TCB_ACESS_ERROR;

	if (read(descriptor,&res,sizeof(res)) <0 )
		return TCB_ACESS_ERROR;
	
	return res;	
}


// returns localFD descriptor
//	   TCB_ACESS_ERROR	
//         FUNC_NOT_FOUND
//	   WCET_FUNC_NOT_FOUND	  			
//         NO_AVAIL_LOCAL_FD
//	   ALREADY_FAILED   
int startTCBLocalFD(int descriptor,TCBtimestamp start_ev, TCBtimeinterval spec, TCBtimeinterval deadline, Func_Id func)
{
	localFDPars* pars;	
	ReqTcbHeader* msg;
	char snd[sizeof(localFDPars)+sizeof(ReqTcbHeader)];
	int res;
	
	msg=(ReqTcbHeader*)&snd;
	pars=(localFDPars*)((ReqTcbHeader*)&snd+1);
	
	msg->srvc=start_localFD;
	msg->sizeofmsg=sizeof(localFDPars);
	
	pars->start_ev=start_ev;
	pars->spec=spec;
	pars->deadline=deadline;
	
	strncpy(pars->funcName,func.funcname,50);
	strncpy(pars->modName,func.module,50);
	strncpy(pars->wcetName,func.wcetname,50);
       	
	if (write(descriptor, &snd,sizeof(ReqTcbHeader)+msg->sizeofmsg) < 0) 
		return TCB_ACESS_ERROR;

	if (read(descriptor,&res,sizeof(res)) <0 )
		return TCB_ACESS_ERROR;	

	return res;	
}



// returns OK
//	   TCB_ACESS_ERROR	
//	   INVALID_LOCALFD_DESC	   
int endTCBLocalFD(int descriptor,int fddesc, TCBtimestamp * end_ev, TCBtimeinterval * procdelay, char * faulty)
{
	char snd[sizeof(int)+sizeof(ReqTcbHeader)];
	ReqTcbHeader* msg;
	endLocalFDResult res;	

	msg=(ReqTcbHeader*)&snd;

	msg->srvc=end_localFD;
	msg->sizeofmsg=sizeof(int);
	
	*((int*)((ReqTcbHeader*)&snd+1))=fddesc;
		
	if (write(descriptor, &snd,sizeof(ReqTcbHeader)+msg->sizeofmsg) < 0) 
		return TCB_ACESS_ERROR;
	
	if (read(descriptor,&res,sizeof(res)) <0 )
		return TCB_ACESS_ERROR;
		
	if (res.stat!=OK) return res.stat;	
		
	*end_ev=res.end_ev;
	*faulty=res.faulty;
	*procdelay=res.procdelay;

	return OK;			
}



// returns socket call pars ou
//	   TCB_ACESS_ERROR  baseado em errno	
int TCBsocket(int family,TCBsocketDesc* desc,int TCBdescriptor)
{
	int tcb_id;
	int one=1;

	desc->socketfd=socket(family,SOCK_DGRAM,0);	
	if (desc->socketfd==-1)	
	 return desc->socketfd;
	 
 	setsockopt(desc->socketfd,SOL_SOCKET,SO_REUSEADDR|SO_BROADCAST,&one,sizeof(one));
	
	tcb_id=getTCBid(TCBdescriptor);
	
	if (tcb_id<0)
	 return TCB_ACESS_ERROR; 
	
	init_session(&desc->rndInfo,(unsigned char)tcb_id);
	desc->rndInfo.TCBdescriptor=TCBdescriptor;
	
	return desc->socketfd;
}

int TCBbind(struct sockaddr *myaddr,int addrlen,TCBsocketDesc* desc)
{
	return bind(desc->socketfd,myaddr,addrlen);	
}


//returns ok
// TCB_ACESS_ERROR
int TCBwinfoport(unsigned int port,TCBsocketDesc* desc)
{	
	char snd[sizeof(port)+sizeof(ReqTcbHeader)];
	ReqTcbHeader* msg;

	msg=(ReqTcbHeader*)&snd;

	msg->srvc=winfo_to_fifo;
	msg->sizeofmsg=sizeof(port);
		
	*((int*)((ReqTcbHeader*)&snd+1))=port;
	
	if (write(desc->rndInfo.TCBdescriptor, &snd,sizeof(ReqTcbHeader)+msg->sizeofmsg) < 0) 
		return TCB_ACESS_ERROR;	
	
	desc->dest_port=port;
	
	return OK;
}

// return sendto result 
int TCBsendto(void* buff,int nbytes,unsigned int flags,struct sockaddr *to,
		int addrlen,TCBsocketDesc* desc,TCBtimestamp send_evt)
{
    return my_send(&(desc->rndInfo),desc->socketfd,buff,nbytes,flags,to,addrlen,NORMAL_MSG,send_evt,0);	
}


//spec in us !!!!
int TCBsendtoWFD(void* buff,int nbytes,unsigned int flags,struct sockaddr *to,
		int addrlen,unsigned char dest_mask,unsigned dest_port,TCBsocketDesc* desc,TCBtimestamp send_evt,TCBtimeinterval spec,TCBtimeinterval deadline,Func_Id func)
{
	ReqTcbHeader* msg;
	long seq;
	distributedFDPars* pars;
	char snd[sizeof(distributedFDPars)+sizeof(ReqTcbHeader)];
	
	if (dest_mask!=0)
	{
	
	msg=(ReqTcbHeader*)&snd;
	pars=(distributedFDPars*)(msg+1);
	
	msg->srvc=start_distributedFD;
	msg->sizeofmsg=sizeof(*pars);
	pars->spec=spec;
	pars->deadline=deadline;
	strcpy(pars->modName,func.module);
	strcpy(pars->funcName,func.funcname);
	strcpy(pars->wcetName,func.wcetname);
	pars->start_ev=send_evt;
	pars->destination_port=dest_port;
	pars->to=dest_mask;    
	
	if (write(desc->rndInfo.TCBdescriptor, &snd, sizeof(snd)) < 0) 
		return TCB_ACESS_ERROR;
	
	if (read(desc->rndInfo.TCBdescriptor,&seq,sizeof(unsigned long)) <0 )
		return TCB_ACESS_ERROR;		
	
	if (seq<0)
	 	return seq;
	 	
	//if (psleep!=0) 	
	// sleep(psleep);	
	} 
	 		
	return my_send(&(desc->rndInfo),desc->socketfd,buff,nbytes,flags,to,addrlen,NORMAL_MSG,send_evt,seq);				
		
}		

int TCBwaitInfo(int wait_info_desc,fail_info_to_app* inf)
{
	if (read(wait_info_desc,inf,sizeof(fail_info_to_app)) <0 )  
		return TCB_ACESS_ERROR;
		
	return OK;	
	
}
						
// return recvfrom stat
//		TCB_ACESS_ERROR  baseado em errno	
int TCBrecvfrom(void* buff,int nbytes,unsigned int flags,struct sockaddr* from,int *addrlen,TCBsocketDesc* desc,
		TCBtimestamp *delivery_evt,TCBtimeinterval* delay,TCBtimeinterval* error,char block)
{
	return my_rcv(&(desc->rndInfo),desc->socketfd,buff,flags,from,addrlen,delay,error,block,delivery_evt);	
}

/*

FOR DEBUG AND TESTING

int TCBrecvfrom2(void* buff,void **data,int nbytes,unsigned int flags,struct sockaddr* from,int *addrlen,TCBsocketDesc* desc,
		unsigned int* tag,TCBtimestamp *delivery_evt,TCBtimeinterval* delay,TCBtimeinterval* error,TCBtimeinterval* delay_using_rndt,TCBtimeinterval* error_using_rndt,char block)
{
	return my_rcv2(&(desc->rndInfo),desc->socketfd,buff,data,flags,from,addrlen,delay,error,delay_using_rndt,error_using_rndt,block,delivery_evt);
}

*/

void TCBsocketClose(TCBsocketDesc* desc,int winfo_desc)
{
	char snd[sizeof(int)+sizeof(ReqTcbHeader)];
	int* dest_port;
	ReqTcbHeader* msg=(ReqTcbHeader*)&snd;
	int ret_val;
	fd_set fds;
	struct timeval tv;
	fail_info_to_app inf;
	dest_port=(int*)(msg+1);
	
	msg->srvc=stop_winfo_port;
	msg->sizeofmsg=sizeof(int);
	*dest_port=desc->dest_port;	
		
	write(desc->rndInfo.TCBdescriptor, &snd,sizeof(ReqTcbHeader)+msg->sizeofmsg);
	
	//flush de winfo
	
	while (1){
	
	FD_ZERO(&fds);
	FD_SET(winfo_desc,&fds);	 		 	
	
	tv.tv_sec=0;
	tv.tv_usec=0;
	
	ret_val=select(winfo_desc+1,&fds,NULL,NULL,&tv);
	 	
	if (!ret_val)
	{
	 close(winfo_desc);
	 return; 
	}
	
	read(winfo_desc,&inf,sizeof(inf));
	
	}
		
	
}		

void printTCBerror(int err)
{
	printf("(TCB ERROR) > ");

	switch (err)
	{
	case	TCB_ACESS_ERROR:printf("Error on the access to TCB");break;
	case	NO_AVAIL_CONN  :printf("No available connection");break;
	case	NO_AVAIL_EXEC  :printf("No available timely execution"); break;
	case	FUNC_NOT_FOUND :printf("Function not found");break;
	case	WCET_FUNC_NOT_FOUND :printf("Worst Case Execution Time function not found");break;
	case	CANT_RUN_TIMELY:printf("TCB Cannot run the function in a timely manner");break;		
	case	NO_AVAIL_LOCAL_FD:printf("Service localFD not available");break;		
	case	ALREADY_FAILED:printf("Cannot timely detect the failure - already failed in the past");break;	
	case	INVALID_LOCALFD_DESC:printf("Invalid local failure detection descriptor");break;	
	case	NO_AVAIL_LOCAL_MEASURE:printf("No available local measurement"); break;
	case	INVALID_LOCALM_DESC:printf("Local measurement descriptor invalid"); break;
	case    TOO_MANY_DISTRIBUTED_FD:printf("Too many simultaneous requests to distributed failure detection service"); break;
        case    BURSTY_SENDS:printf("Bursty invocations to distributed failure detection service"); break;
        case    IN_INIT_STATE:printf("TCB is in initialization"); break;
	}
}


