/*
--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

---------------------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include "share_app_tcb.h"
#include "RndTripApp.h"
#include <errno.h>

typedef struct 
	{
		RndTripInfo  rndInfo;
		int 	     socketfd;	
		unsigned int dest_port;
	}
TCBsocketDesc;

// TCB API

int 		openTCBConnection(int *tcb_desc,int *wait_info_desc);
int 		closeTCBConnection(int descriptor,int wait_info_desc);
TCBtimestamp	getTCBTimestamp(int descriptor);
int		getTCBid(int descriptor);
int		startTCBMeasurement(int descriptor,TCBtimestamp ts);
int	        endTCBMeasurement(int descriptor,int measuredesc,TCBtimeinterval* tm,TCBtimestamp* end_ev);
TCBtimestamp	startTCBExec(int descriptor,TCBtimestamp start_ev, TCBtimeinterval delay, TCBtimeinterval max_exec,Func_Id func,char* TraceName);
int 		startTCBLocalFD(int descriptor,TCBtimestamp start_ev, TCBtimeinterval spec, TCBtimeinterval deadline, Func_Id func);
int 		endTCBLocalFD(int descriptor,int fddesc,TCBtimestamp * end_ev, TCBtimeinterval * procdelay, char * faulty);
int 		TCBsocket(int family,TCBsocketDesc* desc,int TCBdescriptor);
int	        TCBbind(struct sockaddr *myaddr,int addrlen,TCBsocketDesc* desc);
int             TCBwinfoport(unsigned int port,TCBsocketDesc* desc);
int 		TCBsendto(void* buff,int nbytes,unsigned int flags,struct sockaddr *to,
		int addrlen,TCBsocketDesc* desc,TCBtimestamp send_evt);
int 		TCBsendtoWFD(void* buff,int nbytes,unsigned int flags,struct sockaddr *to,
		int addrlen,unsigned char dest_mask,unsigned int dest_port,TCBsocketDesc* desc,TCBtimestamp send_evt,TCBtimeinterval spec,TCBtimeinterval deadline,Func_Id func);				
int 		TCBwaitInfo(int wait_info_desc,fail_info_to_app* inf);
int 		TCBrecvfrom(void* buff,int nbytes,unsigned int flags,struct sockaddr* from,int *addrlen,TCBsocketDesc* desc,
		TCBtimestamp *delivery_evt,TCBtimeinterval* delay,TCBtimeinterval* error,char block);
void 		TCBsocketClose(TCBsocketDesc* desc,int winfo_desc);		
// Para Testes

int TCBrecvfrom2(void* buff,void **data,int nbytes,unsigned int flags,struct sockaddr* from,int *addrlen,TCBsocketDesc* desc,
		unsigned int* tag,TCBtimestamp *delivery_evt,TCBtimeinterval* delay,TCBtimeinterval* error,TCBtimeinterval* delay_using_rndt,TCBtimeinterval* error_using_rndt,char block);
void printTCBerror(int err);		