/*
--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 			
*/	
#include "tcb.h"
#include <signal.h>
#include <sched.h>
#include "../system_defs.h"

char child_stack[1000];
char child_stack_end;
TCBsocketDesc socketDesc;

int thrd1;

char p[4324];

int tcbDesc,wait_info_desc;
char ip_addr[3000];

void exit_on_error(char * msg)
{
	if (errno==0)
	 fprintf(stderr,"%s",msg);
	  else
	   perror(msg);
	   
	kill(thrd1,SIGINT);   
	TCBsocketClose(&socketDesc,wait_info_desc);   
	closeTCBConnection(tcbDesc,wait_info_desc);   
	exit(0);   
}

void sigint_handler(int par)
{
	
	kill(thrd1,SIGINT);    	
	TCBsocketClose(&socketDesc,wait_info_desc);   
	closeTCBConnection(tcbDesc,wait_info_desc);   
	exit(0);
}

int fn(void* arg)
{
	fail_info_to_app fi;
	
	while (1)
	{
	  TCBwaitInfo(wait_info_desc,&fi);  	
	}
	return 0;
}


int main(int argc,char* argv[])
{
	int res;
	
	int ret;	
	TCBtimestamp sndtime,rcv_evt;
	unsigned int tag;
	TCBtimeinterval delay,error;	
	Func_Id p;
 	struct sockaddr_in cnt,serv;
 	int len; 	
 	char buffer[1000];
	void **data;
	unsigned long long cnts;
	MSGheader* pt2;
	int t,a;	
	unsigned char mask=0x1F;
        unsigned char andmask=1; 
	        	
	if (openTCBConnection(&tcbDesc,&wait_info_desc)<OK)
	{
		printTCBerror(ret);
		exit(1);
	}
	
	if ((t=getTCBid(tcbDesc))<OK)
	{
		fprintf(stderr,"Error on geting the ID of the TCB\n");
		closeTCBConnection(tcbDesc,wait_info_desc);   
		exit(1);
	}
	
	if (NUMBER_OF_MACHINES!=1)
	{
	
	for (a=0;a<t;a++)
	 andmask<<=1;		
		
	 andmask=~andmask;
	 mask=mask & andmask;		
	}
	
	//create a thread to read the WaitInfo data  	
	thrd1=clone(&fn,&child_stack_end,CLONE_VM,(void*)0);
	
	signal(SIGINT,sigint_handler);
	
	if ((ret=TCBsocket(AF_INET,&socketDesc,tcbDesc))<0)
	{
		if (errno==0)
		 exit_on_error("Error on the access to the TCB...\n\n");
		  else
		   exit_on_error("Error on creating a TCB socket...\n\n");
	}
	
 	bzero((char*)&cnt,0,sizeof(cnt));
	
 	cnt.sin_family=AF_INET;
 	cnt.sin_addr.s_addr=htonl(INADDR_ANY);
 	cnt.sin_port=htons(0);
 	
 	if ((ret=TCBbind((struct sockaddr*)&cnt,sizeof(cnt),&socketDesc))<0)
 	 {	
 	 	exit_on_error("Error on binding a TCB socket...\n");
 	 }
 	
 	bzero((char*)&serv,0,sizeof(serv));
 	
 	serv.sin_family=AF_INET;
 	serv.sin_addr.s_addr=inet_addr("127.0.0.1");
 	serv.sin_port=htons(16006);
 	
 	
 	strcpy(p.module,"app_module"); 
 	strcpy(p.funcname,"timelyExec"); 
 	strcpy(p.wcetname,"timelyExec_wcet"); 
 	
 	while (1)
 	{
 	 sndtime=getTCBTimestamp(tcbDesc);	
 	 
  	 if ((ret=TCBsendtoWFD((char*)buffer,20,0,(struct sockaddr*)&serv,sizeof(serv),mask,16006,&socketDesc,sndtime,500,2000000,p))<0)
  	  {	
  	  	if ((ret!=ALREADY_FAILED)&&(ret!=BURSTY_SENDS)&&(ret!=TOO_MANY_DISTRIBUTED_FD))													
  	  	exit_on_error("On sending a packet in a TCB socket...\n");
  	  }
  	
  	if ((ret=startTCBLocalFD(tcbDesc,sndtime,5000000,2000000000,p))<0)
  	  {	
  	  	if ((ret!=ALREADY_FAILED)&&(ret!=NO_AVAIL_LOCAL_FD))													
  	  	exit_on_error("on calling the local timing failure detection service\n");
  	  }  
  	  
 	len=sizeof(cnt);
 	if ((ret=TCBrecvfrom((char*)buffer,20,0,(struct sockaddr*)&cnt,&len,&socketDesc,&rcv_evt,&delay,&error,NON_BLOCKING))>0) 	
 	{}	  
 	 else
 	 if (ret<0)   // ret==0 means no info on NON_BLOCKING read
 	  {
 	     exit_on_error("On getting a message from a TCB socket...\n");
 	  }
 	}
}

