/*	
--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 		
*/


#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include "../system_defs.h"
#include "../tcb/messages_formats.h"
#include "../include/driver_defs.h"

int fd0;
	
typedef struct {
	unsigned long mert,mest,mrtv,mrts,mrtr,madfd,malfd;
} tmsg;
	
int main()
{
	tmsg msg;
	FILE* out;	
	unsigned long long TFDmax;

	if ((fd0 = open("/dev/rtf0", O_RDONLY)) < 0) {
		fprintf(stderr, "Error opening /dev/rtf0\n");
		exit(1);
	}
	
	if ((out = fopen("results.inf", "w")) < 0) {
		fprintf(stderr, "Error on creating sys_defs.h\n");
		exit(1);
	}
	
	read(fd0, &msg, sizeof(msg));
	
	printf("Max. exec. time for read task %u nanos\n",msg.mert);
	printf("Max. exec. time for send task %u nanos\n",msg.mest);
	printf("Max. round-trip time %u us\n",msg.mrtv);
	printf("Max. release time for the send task %u nanos\n",msg.mrts);
	printf("Max. release time for the read task %u nanos\n",msg.mrtr);
	printf("Max. delay for a distributed timing detection %u nanos\n",msg.madfd);
	TFDmax=(2*(SEND_PERIOD+READ_PERIOD))+SECURITY_MARGIN_FOR_NODE_CRASH_DETECTION+((MAXIMUM_ROUNDTRIP * 1000)-(MINIMUM_DELIVERY_DELAY * 1000));
	TFDmax+=msg.mert+msg.mrtr;
	printf("  .should be lower than %llu nanos\n", TFDmax);	
	printf("Max. delay for a local timing detection %u nanos\n",msg.malfd);	
	
	fprintf(out,"Max. exec. time for read task %u nanos\n",msg.mert);
	fprintf(out,"Max. exec. time for send task %u nanos\n",msg.mest);
	fprintf(out,"Max. round-trip time %u us\n",msg.mrtv);
	fprintf(out,"Max. release time for the send task %u nanos\n",msg.mrts);
	fprintf(out,"Max. release time for the read task %u nanos\n",msg.mrtr);
	fprintf(out,"Max. delay for a distributed timing detection %u nanos\n",msg.madfd);
	fprintf(out,"  .should be lower than %llu nanos\n", TFDmax);
	fprintf(out,"Max. delay for a local timing detection %u nanos\n",msg.malfd);
	
	fclose(out);
	close(fd0);	
	
}