/*
--[TCB 0.1]---------------------------------------------------

(C) 1999-2001
    Navigators Group - www.navigators.di.fc.ul.pt

       Pedro Martins        Antonio Casimiro    Paulo Verissimo     
    pmartins@di.fc.ul.pt    casim@di.fc.ul.pt   pjv@di.fc.ul.pt    

--------------------------------------------------------------- 			
*/

#include "tcb.h"
#include <signal.h>
#include <sched.h>

char child_stack[1000];
char child_stack_end;

char p[4324];

int thrd1;

int tcbDesc,wait_info_desc;
TCBsocketDesc socketDesc;
void exit_on_error(char * msg)
{
	if (errno==0)
	 fprintf(stderr,"%s",msg);
	  else
	   perror(msg);
	kill(thrd1,SIGINT);      
	TCBsocketClose(&socketDesc,wait_info_desc);      
	closeTCBConnection(tcbDesc,wait_info_desc);   
	exit(1);   
}

void sigint_handler(int par)
{
	kill(thrd1,SIGINT);   
	TCBsocketClose(&socketDesc,wait_info_desc);   
	closeTCBConnection(tcbDesc,wait_info_desc);   
	exit(0);
}


int fn(void* arg)
{
fail_info_to_app fi;
	
	while (1)
	{
	TCBwaitInfo(wait_info_desc,&fi);  	
	}
	return 0;
}

int main()
{
 	int res;
	
	int ret;
	char ip_addr[300];
	TCBtimestamp sndtime,rcv_evt;
	unsigned int tag;
	TCBtimeinterval delay,error;	
 	struct sockaddr_in serv,cnt;
 	int len; 	
 	char buffer[1000];
	void **data;
	fail_info fi[NUMBER_OF_MACHINES];
	
	
	if ( (ret=openTCBConnection(&tcbDesc,&wait_info_desc))<OK)
	{
		printTCBerror(ret);
		exit(1);
	}
	
	thrd1=clone(&fn,&child_stack_end,CLONE_VM,(void*)0);
	
	signal(SIGINT,sigint_handler);
	
	if ((ret=TCBsocket(AF_INET,&socketDesc,tcbDesc))<0)
	{
		if (errno==0)
		 exit_on_error("Error on the access to the TCB...\n\n");
		  else
		   exit_on_error("Error on creating a TCB socket...\n\n");
	}
	
 	bzero((char*)&serv,0,sizeof(cnt));
 	
 	serv.sin_family=AF_INET;
 	serv.sin_addr.s_addr=htonl(INADDR_ANY);
 	serv.sin_port=htons(16006);
 	
 	
 	if ((ret=TCBbind((struct sockaddr*)&serv,sizeof(serv),&socketDesc))<0)
 	 {	
 	 	exit_on_error("Error on binding a TCB socket...\n");
 	 } 	  	  	
 	 
 	if ((ret=TCBwinfoport(16006,&socketDesc))<0)
 	  exit_on_error("Error on spec winfoport...\n");
 	
	while (1)
	{ 	
	
 	len=sizeof(serv); 	
 	
 	if ((ret=TCBrecvfrom((char*)buffer,20,0,(struct sockaddr*)&cnt,&len,&socketDesc,&rcv_evt,&delay,&error,BLOCKING))>0) 	
 	{
 	  sndtime=getTCBTimestamp(tcbDesc);	
 	  
 	 
  	  if ((ret=TCBsendto((char*)buffer,20,0,(struct sockaddr*)&cnt,len,&socketDesc,sndtime))<0)
  	   {
  	   	exit_on_error("On send a packet in a TCB socket...\n");
  	   }
 	}
 	else
 	  exit_on_error("On getting a message from a TCB socket...\n");
 	 	
	} 	
}

